Ruby - Bug #3258

Segmentation fault in Bigdecimal.new
05/08/2010 09:24 AM - tarui (Masaya Tarui)

Status: Closed

Priority: Normal

Assignee:

Target version: 1.9.2

ruby -v: ruby 1.9.2dev (2010-05-07 trunk 27658) |Backport:
[(386-mswin32_90]

Description

=begin

GC.stress = true

require 'bigdecimal’

1000.times({|i| puts BigDecimal.new("1" + "0"*i) }
aaooooa

ruby 1.9.2dev (2010-05-07 trunk 27658) [i386-mswin32_90]
0.1E1

0.1E2

0.1E3

0.1E4

0.1E5

0.1E6

0.1E7

0.1E8

0.1E9

0.1E10

0.46454294919296E12

0.4294892378E12

0.42949672324294858116E16

/soft/ruby/build/t2.rb:3: [BUG] Segmentation fault

ruby 1.9.2dev (2010-05-07 trunk 27658) [i386-mswin32_90]

-- control frame ---=------

c:0009 p:---- s:0022 b:0022 1:000021 d:000021 CFUNC :to_s

¢:0008 p:---- s:0020 b:0020 1:000019 d:000019 CFUNC :puts

¢:0007 p:---- s:0018 b:0018 1:000017 d:000017 CFUNC :puts

c:0006 p:0033 s:0014 b:0014 1:00220c d:000013 BLOCK /soft/ruby/build/t2.rb:3
c:0005 p:---- s:0011 b:0011 1:000010 d:000010 FINISH

c:0004 p:---- s:0009 b:0009 1:000008 d:000008 CFUNC :times

c:0003 p:0040 s:0006 b:0006 1:00220c d:00134c EVAL /soft/ruby/build/t2.rb:3
c:0002 p:---- s:0004 b:0004 1:000003 d:000003 FINISH

¢:0001 p:0000 s:0002 b:0002 1:00220c d:00220c TOP

-- Ruby level backtrace information
/soft/ruby/build/t2.rb:3:in <main>' /soft/ruby/build/t2.rb:3:in times'
/soft/ruby/build/t2.rb:3:in block in <main>' /soft/ruby/build/t2.rb:3:in puts'
/soft/ruby/build/t2.rb:3:in puts' /soft/ruby/build/t2.rb:3:in to_s'

[NOTE]

You may have encountered a bug in the Ruby interpreter or extension libraries.
Bug reports are welcome.

For details: http://www.ruby-lang.org/bugreport.html

This application has requested the Runtime to terminate it in an unusual way.
Please contact the application's support team for more information.
Index: ext/bigdecimal/bigdecimal.c

--- ext/bigdecimal/bigdecimal.c (10000 27662)
+++ ext/bigdecimal/bigdecimal.c (I0000)
@@ -2593,7 +2593,7 @@

int sign=1;

Real *vp = NULL;

U_LONG mf = VpGetPrecLimit();

e volatile VALUE buf;
e VALUE buf;

mx = (mx + BASE_FIG - 1) / BASE_FIG + 1; /* Determine allocation unit. /
if(szVal) {

@@ -2720,6 +2720,7 @@

vp->MaxPrec = mx; /set max precision */

VpSetZero(vp,sign);

VpCtoV(vp, &(szVallipn]), ni, &(szVal[ipf]), nf, &(szVallipe]), ne);

e RB_GC_GUARD(buf);
return vp;

}

=end

History

#1 - 05/08/2010 11:17 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed
- % Done changed from 0 to 100

=begin

This issue was solved with changeset r27665.
masaya, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

=end
